<?php

use EventPortal\Domain\Agenda\Models\Agenda;
use EventPortal\Domain\Agenda\Models\Pathway;
use EventPortal\Domain\Agenda\Models\Session;
use Faker\Generator as Faker;
use Illuminate\Support\Carbon;

/** @var \Illuminate\Database\Eloquent\Factory $factory */

$factory->define(Session::class, static function (Faker $faker) {
    return [
        'pathway_id' => function () {
            return factory(Pathway::class)->create()->id;
        },
        'agenda_id' => function () {
            return factory(Agenda::class)->create()->id;
        },
        'name' => $faker->word,
        'description' => $faker->words(5, true),
        'starting_at' => Carbon::parse('09:00 AM'),
        'ending_at' => Carbon::parse('10:00 AM'),
        'location' => 'Reception',
    ];
});
