<?php

namespace EventPortal\Domain\Component;

class Display extends Input
{
    const TYPE = 'TextData';

    public function asReadableBoolean(): self
    {
        $this->readableBoolean = true;

        return $this;
    }

    /**
     * @param string|array $value
     * @return $this
     */
    public function value($value): Input
    {
        if (property_exists($this, 'readableBoolean') && $this->readableBoolean) {
            $this->value = $value === true ? 'Yes' : 'No';

            return $this;
        }

        $this->value = Value::get($value);

        return $this;
    }
}
