<?php

namespace EventPortal\Http\Controllers\Admin\EventSpeaker;

use EventPortal\Concerns\EventRequiresReApproval;
use EventPortal\Domain\Event\Models\Event;
use EventPortal\Domain\EventSpeaker\Actions\AssociateToEvent;
use EventPortal\Http\Controllers\Controller;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;

class AssociateToEventController extends Controller
{
    use EventRequiresReApproval;

    public function __construct()
    {
        $this->middleware('check-permission:event-speaker.add');
    }

    public function __invoke(Request $request, Event $event, AssociateToEvent $action): RedirectResponse
    {
        $action->execute($event, $request->all());

        if ($this->doesEventRequireReApproval($event)) {
            $event->updateApprovalStatusToRequireResubmission();
        }

        toast()->success(trans('event-speaker.added'));

        return redirect()->route('admin.event.speaker.index', $event);
    }
}
