<?php

namespace EventPortal\Tests\Feature\Admin\Speaker;

use EventPortal\Domain\Speaker\Models\Speaker;
use EventPortal\Domain\User\Models\User;
use EventPortal\Tests\Support\Traits\SeedRolesAndPermissions;
use EventPortal\Tests\TestCase;
use Illuminate\Foundation\Testing\DatabaseMigrations;
use Spatie\Snapshots\MatchesSnapshots;

class SpeakerCreateTest extends TestCase
{
    use DatabaseMigrations, MatchesSnapshots, SeedRolesAndPermissions;

    /** @test **/
    public function can_create_a_speaker(): void
    {
        $this
            ->actingAsSuperAdmin()
            ->post(route('admin.speaker.store'), [
                'first_name' => 'Firstname',
                'last_name' => 'Lastname',
                'email' => 'test@example.com',
            ])
            ->assertRedirect(route('admin.speaker.show', Speaker::first()->id));

        $speaker = Speaker::first();
        $this->assertCount(2, User::all());
        $this->assertEquals('Firstname Lastname', $speaker->name);
        $this->assertEquals('test@example.com', $speaker->user->email);
    }
}
