<?php

namespace EventPortal\Tests\Unit\ActionList;

use EventPortal\Domain\ActionList\ActionList;
use EventPortal\Domain\ActionList\Facades\ActionListTemplate;
use EventPortal\Domain\ActionList\Task;
use EventPortal\Tests\TestCase;
use Spatie\Snapshots\MatchesSnapshots;

class ActionListTemplateTest extends TestCase
{
    use MatchesSnapshots;

    /** @test **/
    public function can_add_list()
    {
        $actionList = ActionList::state('draft')
            ->addTask(function () {
                return [
                    Task::make()->label('Simple task'),
                ];
            });

        $actionListTemplate = ActionListTemplate::make('default')->addList($actionList);

        $this->assertMatchesJsonSnapshot($actionListTemplate->get()->lists);
    }

    /** @test **/
    public function can_add_multiple_lists()
    {
        $actionListA = ActionList::state('draft')
            ->addTask(function () {
                return [
                    Task::make()->label('Simple task'),
                ];
            });

        $actionListB = ActionList::state('draft')
            ->addTask(function () {
                return [
                    Task::make()->label('Another task'),
                ];
            });

        $actionListTemplate = ActionListTemplate::make('default')
            ->addList($actionListA)
            ->addList($actionListB);

        $this->assertMatchesJsonSnapshot($actionListTemplate->get()->lists);
    }
}
